unit utuEmprestimoOQL;

interface

uses acuOQL, acuFramework;

type

  IObterClientes = interface(IOQLQuery)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  IObterExemplares = interface(IOQLQuery)
    function Param_titulo: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

  utEmprestimoOQL = class
    class function ObterClientes(piSessao: acPersistenceSession): IObterClientes;
    class function ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
  end;

implementation

type

  TObterClientes = class(acOQLQuery, IObterClientes)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  TObterExemplares = class(acOQLQuery, IObterExemplares)
    function Param_titulo: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

{ TObterClientes }

function TObterClientes.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterClientes.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ TObterExemplares }

function TObterExemplares.Param_titulo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('titulo'));
end;

function TObterExemplares.Param_codigo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('codigo'));
end;

{ utOQLs }

class function utEmprestimoOQL.ObterClientes(piSessao: acPersistenceSession): IObterClientes;
begin
  result := TObterClientes.Create(pisessao,
'SELECT ngCliente' + #13#10 +
'FROM ngCliente' + #13#10 +
'WHERE (ngCliente.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL)' + #13#10 +
'	AND (ngCliente.CPF = ?cpf:acString OR ?cpf:acString IS NULL)');
end;

class function utEmprestimoOQL.ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
begin
  result := TObterExemplares.Create(pisessao,
'SELECT ngExemplar' + #13#10 +
'FROM ngExemplar' + #13#10 +
'WHERE (ngExemplar.Livro.Titulo LIKE ''%''+?titulo:acString+''%'' OR ?titulo:acString IS NULL)' + #13#10 +
'	AND (ngExemplar.Codigo = ?codigo:acString OR ?codigo:acString IS NULL)' + #13#10 +
'ORDER BY ngExemplar.Livro.OID');
end;

end.
